/* icode.c
	P. Chongstitvatana
							27 Aug 97
   add tmSend, tmSignal, tmWait, delay, gettime		21 Aug 98
	start project RZ				3 Apr 2001

*/

#include "compile.h"

#define		PRIVATE		static

#include "iname.h"

uchar CS[MAXCS];
int CP = 1;

/*-----------------------*/
/* track as <-> code */
int CSLINE[MAXCS];
int CPLINE = 1;

/*-----------------------*/

extern FILE *FO;

PRIVATE int getInt(int i)
{
  return CS[i]*256 + CS[i+1];
}

void showCode()
{
  int c,i,ip = 1;
  while( ip < CP ) {
    c = CS[ip];
    fprintf(FO,"\n%5d %s ",ip,icProp[c].str);
    ip++;
    for(i=1; i<icProp[c].len; i+=2) {
      fprintf(FO,"%d ",CS[ip]*256 + CS[ip+1]);
      ip += 2;
    }
  }
}

void out( uchar code )
{
  CSLINE[CP] = CPLINE ; /* ---- */
  CS[CP] = code;
  CP++;
}

void out1( int c1 )
{
  CSLINE[CP] = CPLINE ; /* ---- */
  CSLINE[CP+1] = CPLINE ; /* ---- */

  CS[CP] = c1 / 256;
  CS[CP+1] = c1 % 256;
  CP += 2;
}

void out2( uchar c1, int c2 )
{
  CSLINE[CP] = CPLINE ; /* ---- */
  CSLINE[CP+1] = CPLINE ; /* ---- */
  CSLINE[CP+2] = CPLINE ; /* ---- */

  CS[CP] = c1;
  CS[CP+1] = c2 / 256;
  CS[CP+2] = c2 % 256;
  CP += 3;
}

void out3( uchar c1, int c2, int c3 )
{
  CSLINE[CP] = CPLINE ; /* ---- */
  CSLINE[CP+1] = CPLINE ; /* ---- */
  CSLINE[CP+2] = CPLINE ; /* ---- */
  CSLINE[CP+3] = CPLINE ; /* ---- */
  CSLINE[CP+4] = CPLINE ; /* ---- */

  CS[CP] = c1;
  CS[CP+1] = c2 / 256;
  CS[CP+2] = c2 % 256;
  CS[CP+3] = c3 / 256;
  CS[CP+4] = c3 % 256;
  CP += 5;
}

void patch( int ads, int v )
{
  CS[ads] = v / 256;
  CS[ads+1] = v % 256;
}

void dumpCode()
{
  int i;
  for( i=1; i<CP; i++ ) putc(CS[i],FO);
}

void reName()
{
  int i,type,ref,arg,n;
  n = 0;
  for( i=1; i<CP; i += icProp[CS[i]].len ) {
    switch( CS[i] ) {
    case icFunc : n = getInt(i+1) + getInt(i+3); break;
    case icLval :
    case icRval : patch(i+1, n - getInt(i+1)+1 ); break;
    case icCall :
		getAt(getInt(i+1),&type,&ref,&arg);
		patch(i+1,ref);
		break;
    }
  }
}

